;File:      alarm001.asm
;Revision:  0
;Date:      15-12-2002
;Subject:   inbraak alarm
IE           .equ 0A8H
ACC          .equ 0E0H
B            .equ 0F0H
PSW          .equ 0D0H
DPL          .equ 082H
DPH          .equ 083H
PCON         .equ 087H
TCON         .equ 088H     
TMOD         .equ 089H
TL0          .equ 08AH
TH0          .equ 08CH
P0           .equ 080H
P1           .equ 090H
P2           .equ 0A0H
P3           .equ 0B0H
P2.0         .equ 0A0H
P2.1         .equ 0A1H
P2.2         .equ 0A2H
P2.3         .equ 0A3H
P2.4         .equ 0A4H
P2.5         .equ 0A5H
P2.6         .equ 0A6H
P2.7         .equ 0A7H
TR1          .equ 08EH
IT0          .equ 088H
RI           .equ 098H
TI           .equ 099H
ES           .equ 0ACH
EA           .equ 0AFH
TR0          .equ 08CH
IE0          .equ 089H

IP1V0        .equ 050H
IP1V1        .equ 051H
IP1V2        .equ 052H
IP2V0        .equ 053H
IP2V1        .equ 054H
IP2V2        .equ 055H
IP3V0        .equ 056H
IP3V1        .equ 057H
IP3V2        .equ 058H
P1V0         .equ 059H
P1V1         .equ 05AH
P1V2         .equ 05BH
P2V0         .equ 05CH
P2V1         .equ 05DH
P2V2         .equ 05EH
P3V0         .equ 05FH
P3V1         .equ 060H
P3V2         .equ 061H
P1A          .equ 062H
P2A          .equ 063H
P3A          .equ 064H
P1R          .equ 065H
P3R          .equ 066H
PANTIMER     .equ 067H
UITTIMER     .equ 068H
INLTIMER     .equ 069H
ALXTIMER     .equ 06AH
ALYTIMER     .equ 06BH
P1O          .equ 06CH
P2O          .equ 06DH
P3O          .equ 06EH
DIO          .equ 06FH
STATUS       .equ 070H
COUNT1       .equ 071H
COUNT2       .equ 072H
COUNT3       .equ 073H
TOGGLE       .equ 074H
OUTPUT       .equ 075H

ACC.0        .equ 0E0H
ACC.1        .equ 0E1H
ACC.2        .equ 0E2H
ACC.3        .equ 0E3H
ACC.4        .equ 0E4H
ACC.5        .equ 0E5H
ACC.6        .equ 0E6H
ACC.7        .equ 0E7H
B.0          .equ 0F0H
B.1          .equ 0F1H
B.2          .equ 0F2H
B.3          .equ 0F3H
B.4          .equ 0F4H
B.5          .equ 0F5H
B.6          .equ 0F6H
B.7          .equ 0F7H

PANVAL       .equ 12            ;5x12=60 seconde voor paniektimer
UITVAL       .equ 12            ;5x12=60 seconde voor uitlooptimer
INLVAL       .equ 12            ;5x12=60 seconde voor inlooptimer
ALXVAL       .equ 12            ;5x12=60 seconde voor output X timer
ALYVAL       .equ 12            ;5x12=60 seconde voor output Y timer
T0valu       .equ 250           ;250 usec voor timer 0 

        .org  0000H             ;start adress after reset
        LJMP  START 
        .org  000BH             ;start adress after interrupt TF1
        LJMP  INTT0
        .org  0200H
;-------------------------------------------------------------------------------------
;INITIALISATIE VARIABELEN
;-------------------------------------------------------------------------------------
START  MOV   COUNT1,#040
       MOV   COUNT2,#050
       MOV   COUNT3,#010
       ORL   P1,#11111111B      ;P1 is input
       ORL   P3,#11111111B      ;P3 is input
       SETB  P2.0               ;P2.0 is input (activeer alarm)
       SETB  P2.1               ;P2.1 is input (paniek)
       SETB  P2.2               ;P2.2 is input (sabotage)
       MOV   STATUS,#00000000B
       MOV   IP1V0,#000H
       MOV   IP1V1,#000H
       MOV   IP1V2,#000H
       MOV   IP2V0,#000H
       MOV   IP2V1,#000H
       MOV   IP2V2,#000H
       MOV   IP3V0,#000H
       MOV   IP3V1,#000H
       MOV   IP3V2,#000H
       MOV   P1V0,#000H
       MOV   P1V1,#000H
       MOV   P1V2,#000H
       MOV   P2V0,#000H
       MOV   P2V1,#000H
       MOV   P2V2,#000H
       MOV   P3V0,#000H
       MOV   P3V1,#000H
       MOV   P3V2,#000H
       MOV   P1A,#000H
       MOV   P2A,#000H
       MOV   P3A,#000H
       MOV   TOGGLE,#0FFH
;-------------------------------------------------------------------------------------
;INITIALISEER INTERRUPT AFHANDELING
;-------------------------------------------------------------------------------------
SINT   MOV   TH0,#256-T0valu    ;elke 250 usec interrupt door timer 0
       MOV   TL0,#256-T0valu    ;
       ANL   TMOD,#11110000B    ;timer 0 in mode 2
       ORL   TMOD,#00000010B    ;
       SETB  TR0                ;start timer 0
       ORL   IE,#10000010B      ;set bit ENABLE ALL INTERRUPTS en bit ENABLE TIMER 0
                                ;INTERRUPT
;-------------------------------------------------------------------------------------
;INITIALISATIE PROGRAMMA
;-------------------------------------------------------------------------------------
INIT   MOV   P0,#000H           ;led test na inschakelen spanning
       ANL   P2,#00000111B
       MOV   R3,#016            ;delay: (4xR2xR3+2xR1xR2xR3+4xR3+2)/1000 [sec]
INIT1  MOV   R2,#250            ;delay: (4x250x16+2x248x250x16+4x16+2)/1000 = 2,000066
INIT2  MOV   R1,#248
INIT3  DJNZ  R1,INIT3
       DJNZ  R2,INIT2
       DJNZ  R3,INIT1
;-------------------------------------------------------------------------------------
;MAIN PROGRAMMA
;-------------------------------------------------------------------------------------
MAIN   ANL   IE,#11111101B      ;TIMER0 interrupt uit
       MOV   P1V2,IP1V2         ;zet interrupt variabelen op lokale variabelen
       MOV   P1V1,IP1V1
       MOV   P1V0,IP1V0
       MOV   P2V2,IP2V2
       MOV   P2V1,IP2V1
       MOV   P2V0,IP2V0
       MOV   P3V2,IP3V2
       MOV   P3V1,IP3V1
       MOV   P3V0,IP3V0
       ORL   IE,#00000010B      ;TIMER0 interrupt aan

       MOV   A,P1V0             ;filter inputs P1, P2 en P3
       ORL   A,P1V1             ;drie achereenvolgende interrupts hoog of laag
       ORL   A,P1V2             ;dan wordt dit niveau op P1A, P2A en P3A geplaatst
       ANL   A,P1A
       MOV   P1A,A
       MOV   A,P1V0
       ANL   A,P1V1
       ANL   A,P1V2
       ORL   A,P1A
       MOV   P1A,A

       MOV   A,P2V0
       ORL   A,P2V1
       ORL   A,P2V2
       ANL   A,P2A
       MOV   P2A,A
       MOV   A,P2V0
       ANL   A,P2V1
       ANL   A,P2V2
       ORL   A,P2A
       MOV   P2A,A

       MOV   A,P3V0
       ORL   A,P3V1
       ORL   A,P3V2
       ANL   A,P3A
       MOV   P3A,A
       MOV   A,P3V0
       ANL   A,P3V1
       ANL   A,P3V2
       ORL   A,P3A
       MOV   P3A,A

       MOV   B,P1A              ;rangeren van ingangen P1 en P3
       MOV   C,B.2              ;P1A.2 -> P1R.1
       MOV   B.1,C
       MOV   C,B.4              ;P1A.4 -> P1R.2
       MOV   B.2,C
       MOV   C,B.6              ;P1A.6 -> P1R.3
       MOV   B.3,C
       MOV   A,P3A
       MOV   C,ACC.0            ;P3A.0 -> P1R.4
       MOV   B.4,C
       MOV   C,ACC.2            ;P3A.2 -> P1R.5
       MOV   B.5,C
       MOV   C,ACC.4            ;P3A.4 -> P1R.6
       MOV   B.6,C
       MOV   C,ACC.6            ;P3A.6 -> P1R.7
       MOV   B.7,C
       MOV   P1R,B

       MOV   B,P3A
       MOV   C,B.5              ;P3A.5 -> P3R.6
       MOV   B.6,C
       MOV   C,B.3              ;P3A.3 -> P3R.5
       MOV   B.5,C
       MOV   C,B.1              ;P3A.1 -> P3R.4
       MOV   B.4,C 
       MOV   A,P1A
       MOV   C,ACC.7            ;P1A.7 -> P3R.3
       MOV   B.3,C
       MOV   C,ACC.5            ;P1A.5 -> P3R.2
       MOV   B.2,C
       MOV   C,ACC.3            ;P1A.3 -> P3R.1
       MOV   B.1,C
       MOV   C,ACC.1            ;P1A.1 -> P3R.0
       MOV   B.0,C
       MOV   P3R,B
  
;-------------------------------------------------------------------------------------
;PANIEK - na indrukken drukknop PANIEK wordt paniekbit geset en paniektimer gestart,
;         na aflopen van paniektimer wordt paniekbit gereset.
;-------------------------------------------------------------------------------------
PAN    MOV   A,P2A
       JB    ACC.1,PAN1         ;jump, drukknop PANIEK niet ingedrukt
       MOV   A,STATUS
       JB    ACC.0,PAN2         ;jump, drukknop PANIEK is geset
       ORL   STATUS,#00000001B  ;set drukknop PANIEK
       MOV   A,STATUS
       JB    ACC.1,PAN3         ;jump, paniekbit is geset
       ORL   STATUS,#00000010B  ;set paniekbit
       MOV   PANTIMER,#PANVAL   ;preset paniektimer
       SJMP  PAN2
PAN3   ANL   STATUS,#11111101B  ;reset paniekbit
       SJMP  PAN2
PAN1   ANL   STATUS,#11111110B  ;reset drukknop PANIEK
PAN2   MOV   A,PANTIMER
       JNZ   ALA                ;jump, paniektimer niet afgelopen
       ANL   STATUS,#11111101B  ;reset paniekbit         
;-------------------------------------------------------------------------------------
;ALARM -
;-------------------------------------------------------------------------------------
ALA    MOV   A,P2A
       JB    ACC.0,ALA1         ;jump, alarm ingeschakeld
       ANL   STATUS,#00001111B  ;reset alarmbits
       LJMP  VIS                ;jump, alarm niet ingeschakeld
ALA1   MOV   A,STATUS
       ANL   A,#11110000B       ;maskeer alarmbits
       JNZ   ALA2               ;jump, alarm reeds actief
                                ;alarm mag alleen worden geactiveerd als er
       MOV   A,P1R              ;geen alarm/tamper/sabotage aanwezig is
       JNZ   ALA2               ;jump, alarm-contacten niet allen gesloten
       MOV   A,P2A
       JB    ACC.2,ALA2         ;jump, sabotage-contact niet gesloten
       MOV   A,P3R
       JNZ   ALA2               ;jump, tamper-contacten niet allen gesloten
       ORL   STATUS,#00010000B  ;set alarmbit UITLOOPVERTRAGING
       MOV   UITTIMER,#UITVAL   ;preset uitlooptimer

ALA2   MOV   A,STATUS           ;check, is uitloopvertraging afgelopen
       ANL   A,#00010000B       ;maskeer alarmbit UITLOOPVERTRAGING
       JZ    ALA3               ;jump, uitloopvertraging niet actief
       MOV   A,UITTIMER
       JNZ   ALA3               ;jump, uittimer niet afgelopen
       ORL   STATUS,#00100000B  ;set alarmbit NORMAAL
       ANL   STATUS,#11101111B  ;reset alarmbit UITLOOPVERTRAGING

ALA3   MOV   A,STATUS           ;check, is alarm opgetreden
       ANL   A,#00100000B       ;maskeer alarmbit NORMAAL
       JZ    ALA4               ;jump, normaal alarmbedrijf niet actief
       MOV   A,P1R              ;controleer alarm-contacten
       JZ    ALA4               ;jump, geen alarm
       ORL   STATUS,#01000000B  ;set alarmbit INLOOPVERTRAGING
       ANL   STATUS,#11011111B  ;reset alarmbit NORMAAL
       MOV   INLTIMER,#INLVAL   ;preset inlooptimer
       MOV   P1O,P1R            ;bewaar P1R die alarm heeft veroorzaakt
       MOV   P2O,P2A            ;bewaar eveneens P2A (geen alarm veroorzaakt)
       MOV   P3O,P3R            ;bewaar eveneens P3R (geen alarm veroorzaakt)

ALA4   MOV   A,STATUS           ;check, is inlooptimer afgelopen
       ANL   A,#01000000B       ;maskeer alarmbit INLOOPVERTRAGING
       JZ    ALA5               ;jump, inloopvertraging niet actief
       MOV   A,INLTIMER
       JNZ   ALA5               ;jump, inlooptimer niet afgelopen
       ORL   STATUS,#10000000B  ;set alarmbit ALARM
       ANL   STATUS,#10111111B  ;reset alarmbit NORMAAL

ALA5   MOV   A,STATUS           ;check, is tamper of sabotage opgetreden
       ANL   A,#01100000B       ;maskeer alarmbits NORMAAL en INLOOPVERTRAGING
       JZ    VIS                ;jump, alarmbedrijf NORMAAL en INLOOPVERTRAGING niet
                                ;actief
       MOV   A,P3R              ;controleer tamper-contacten
       JZ    ALA6               ;jump, geen tamper
       ORL   STATUS,#10000000B  ;set alarmbit ALARM
       ANL   STATUS,#10011111B  ;reset alarmbit NORMAAL en alarmbit UITLOOPVERTRAGING
       MOV   P1O,P1R            ;bewaar P1R (geen alarm veroorzaakt)
       MOV   P2O,P2A            ;bewaar eveneens P2A (geen alarm veroorzaakt)
       MOV   P3O,P3R            ;bewaar eveneens P3R die alarm heeft veroorzaakt

ALA6   MOV   A,P2A              ;controleer sabotage-contact
       JNB   ACC.2,VIS          ;jump, geen sabotage
       ORL   STATUS,#10000000B  ;set alarmbit ALARM
       ANL   STATUS,#10011111B  ;reset alarmbit NORMAAL en alarmbit UITLOOPVERTRAGING
       MOV   P1O,P1R            ;bewaar P1R (geen alarm veroorzaakt)
       MOV   P2O,P2A            ;bewaar eveneens P2A die alarm heeft veroorzaakt
       MOV   P3O,P3R            ;bewaar eveneens P3R (geen alarm veroorzaakt)
;-------------------------------------------------------------------------------------
;VISUALISATIE - 
; led ALARM INGESCHAKELD:          uit:       alarm niet ingeschakeld
;                                  knipperen: uitloopvertraging actief
;                                  aan:       alarm ingeschakeld
; led ALARM ACTIEF:                uit:       alarm niet actief
;                                  knipperen: inloopvertraging actief
;                                  aan:       alarm geactiveerd 
; led SENSOR:   alarm niet actief: uit:       sensor niet geactiveerd
;                                  knipperen: draadbreuk desbetreffende sensor
;                                  aan:       sensor geactiveerd
;               alarm actief:      uit:       desbetreffende sensor heeft alarm niet
;                                             veroorzaakt
;                                  knipperen: desbetreffende sensor heeft door tamper-
;                                             contact of draadbreuk alarm veroorzaakt
;                                  aan:       desbetreffende zensor heeft door alarm-
;                                             contact alarm veroorzaakt
; led SABOTAGE: alarm niet actief: uit:       sensor niet geactiveerd
;                                  aan:       sensor geactiveerd
;               alarm actief:      uit:       desbetreffende sensor heeft alarm niet
;                                             veroorzaakt
;                                  aan:       desbetreffende sensor heeft door alarm-
;                                             contact alarm veroorzaakt
;-------------------------------------------------------------------------------------
VIS    MOV   A,STATUS           ;check, is alarm actief
       ANL   A,#10000000B       ;maskeer alarmbit ALARM
       JNZ   VIS1               ;jump, alarm actief 
       MOV   A,P1R              ;inverteer P1R en sla op in B
       CPL   A
       MOV   B,A
       MOV   A,P3R              ;inverteer P3R, AND met B en sla op in B
       CPL   A
       ANL   A,B
       MOV   B,A
       MOV   A,P3R              ;AND P3R met TOGGLE, OR met B en zet op P0
       ANL   A,TOGGLE
       ORL   A,B
       MOV   P0,A
       MOV   A,P2A              ;led SABOTAGE
       MOV   C,ACC.2
       CPL   C
       MOV   P2.5,C
       SJMP  VIS2

VIS1   MOV   A,P1O              ;inverteer P1O en sla op in B
       CPL   A
       MOV   B,A
       MOV   A,P3O              ;inverteer P3O, AND met B en sla op in B
       CPL   A
       ANL   A,B
       MOV   B,A
       MOV   A,P3O              ;AND P3O met TOGGLE, OR met B en zet op P0
       ANL   A,TOGGLE
       ORL   A,B
       MOV   P0,A
       MOV   A,P2O              ;led SABOTAGE
       MOV   C,ACC.2
       CPL   C
       MOV   P2.5,C

VIS2   MOV   A,STATUS           ;LED ALARM INGESCHAKELD
       ANL   A,#11110000B       ;maskeer alarmbits
       JNZ   VIS3               ;jump, alarm actief
       SETB  P2.7               ;led ALARM INGESCHAKELD uit

VIS3   MOV   A,STATUS
       ANL   A,#00010000B       ;maskeer alarmbit UITLOOPVERTRAGING
       JZ    VIS5               ;jump, uitloopvertraging niet actief
       MOV   A,TOGGLE
       JZ    VIS4
       CLR   P2.7               ;led ALARM INGESCHAKELD knipperen
       SJMP  VIS5
VIS4   SETB  P2.7               ;led ALARM INGESCHAKELD knipperen

VIS5   MOV   A,STATUS
       ANL   A,#11100000B       ;maskeer alarmbits NORMAAL, INLOOPVERTRAGING en ALARM
       JZ    VIS6               ;jump, alarmbits NORMAAL, INLOOPVERTRAGING en ALARM niet actief
       CLR   P2.7               ;led ALARM INGESCHAKELD aan

VIS6   MOV   A,STATUS           ;LED ALARM ACTIEF
       ANL   A,#11000000B       ;maskeer alarmbits INLOOPVERTRAGING en ALARM
       JNZ   VIS7               ;jump, INLOOPVERTRAGING of ALARM actief
       SETB  P2.6               ;led ALARM ACTIEF uit

VIS7   MOV   A,STATUS
       ANL   A,#01000000B       ;maskeer alarmbit INLOOPVERTRAGING
       JZ    VIS8               ;jump, inloopvertraging niet actief
       MOV   A,TOGGLE
       JZ    VIS9
       CLR   P2.6               ;led ALARM ACTIEF knipperen
       SJMP  VIS8
VIS9   SETB  P2.6               ;led ALARM ACTIEF knipperen

VIS8   MOV   A,STATUS
       ANL   A,#10000000B       ;maskeer alarmbit ALARM
       JZ    OUT                ;jump, alarmbit ALARM niet actief
       CLR   P2.6               ;led ALARM ACTIEF aan
;-------------------------------------------------------------------------------------
;OUTPUTS
;-------------------------------------------------------------------------------------
OUT    MOV   A,OUTPUT
       ANL   A,#00001111B       ;maskeer OUTPUT X bits
       JNZ   OUT1               ;jump, OUTPUT X bits reeds actief
       MOV   A,STATUS           ;check, is alarm actief
       ANL   A,#10000000B
       JZ    OUT1               ;jump, alarm niet actief
       ORL   OUTPUT,#00000001B  ;set bit OUTPUT X eerste fase
       MOV   ALXTIMER,#ALXVAL   ;preset output X timer

OUT1   MOV   A,OUTPUT           ;check, OUTPUT X eerste fase
       ANL   A,#00000001B
       JZ    OUT2               ;jump, OUTPUT X niet in eerste fase
       MOV   A,ALXTIMER
       JNZ   OUT2               ;jump, alarmtimer niet afgelopen
       ANL   OUTPUT,#11111110B  ;reset bit OUTPUT X eerste fase
       ORL   OUTPUT,#00000010B  ;set bit OUTPUT X tweede fase

OUT2   MOV   A,STATUS
       ANL   A,#10000000B       ;maskeer alarmbit ALARM
       JNZ   OUT3               ;jump, alarm nog actief
       ANL   OUTPUT,#11110000B  ;reset OUTPUT X bits

OUT3   MOV   A,OUTPUT
       ANL   A,#11110000B       ;maskeer OUTPUT Y bits
       JNZ   OUT4               ;jump, OUTPUT Y bits reeds actief
       MOV   A,STATUS           ;check, is alarm actief
       ANL   A,#10000000B
       JZ    OUT4               ;jump, alarm niet actief
       ORL   OUTPUT,#00010000B  ;set bit OUTPUT Y eerste fase
       MOV   ALYTIMER,#ALYVAL   ;preset output Y timer

OUT4   MOV   A,OUTPUT           ;check, OUTPUT Y eerste fase
       ANL   A,#00010000B
       JZ    OUT5               ;jump, OUTPUT Y niet in eerste fase
       MOV   A,ALYTIMER
       JNZ   OUT5               ;jump, alarmtimer niet afgelopen
       ANL   OUTPUT,#11101111B  ;reset bit OUTPUT Y eerste fase
       ORL   OUTPUT,#00100000B  ;set bit OUTPUT Y tweede fase

OUT5   MOV   A,STATUS
       ANL   A,#10000000B       ;maskeer alarmbit ALARM
       JNZ   OUT6               ;jump, alarm nog actief
       ANL   OUTPUT,#00001111B  ;reset OUTPUT Y bits

OUT6   MOV   A,OUTPUT
       ANL   A,#00000001B       ;maskeer OUTPUT X eerste fase
       JNZ   OUT7               ;jump, OUTPUT X eerste fase actief
       MOV   A,STATUS           ;check, paniekbit actief
       ANL   A,#00000010B       ;maskeer paniekbit
       JNZ   OUT7               ;jump, paniekbit actief
       CLR   P2.4               ;deactiveer OUTPUT X
       SJMP  OUT8
OUT7   SETB  P2.4               ;activeer OUTPUT X

OUT8   MOV   A,OUTPUT
       ANL   A,#00010000B       ;maskeer OUTPUT Y eerste fase
       JNZ   OUT9               ;jump, OUTPUT Y eerste fase actief
       MOV   A,STATUS           ;check, paniekbit actief
       ANL   A,#00000010B       ;maskeer paniekbit
       JNZ   OUT9               ;jump, paniekbit actief
       CLR   P2.3               ;deactiveer OUTPUT Y
       SJMP  EIND
OUT9   SETB  P2.3               ;activeer OUTPUT Y

EIND   LJMP  MAIN
;-------------------------------------------------------------------------------------
;INTERRUPT ROUTINE INTT0
;-------------------------------------------------------------------------------------
INTT0   PUSH  PSW
        PUSH  ACC
        DJNZ  COUNT1,IRET       ;decrement COUNT1, jump, COUNT1 <> 0
        MOV   COUNT1,#040       ;elke 10 msec (250 x 40 = 10 msec)
        MOV   IP1V2,IP1V1
        MOV   IP1V1,IP1V0
        MOV   IP1V0,P1
        MOV   IP2V2,IP2V1
        MOV   IP2V1,IP2V0
        MOV   IP2V0,P2
        MOV   IP3V2,IP3V1
        MOV   IP3V1,IP3V0
        MOV   IP3V0,P3
        DJNZ  COUNT2,IRET       ;decrement COUNT2, jump, COUNT2 <> 0
        MOV   COUNT2,#050       ;elke 500 msec (250 x 40 x 50 = 500 msec)
        MOV   A,TOGGLE
        CPL   A
        MOV   TOGGLE,A
        DJNZ  COUNT3,IRET       ;decrement COUNT3, jump, COUNT3 <> 0
        MOV   COUNT3,#010       ;elke 5 seconde (250 x 40 x 50 x 10 = 5 sec)
        DEC   PANTIMER          ;decrement countdown teller paniektimer
        DEC   UITTIMER          ;decrement countdown teller uitlooptimer
        DEC   INLTIMER          ;decrement countdown teller inlooptimer
        DEC   ALXTIMER          ;decrement countdown teller alarmtimer
        DEC   ALYTIMER          ;decrement countdown teller alarmtimer
IRET    POP   ACC
        POP   PSW
        RETI

       .end
       .end